; Altirra Acid800 test suite
; Copyright (C) 2010 Avery Lee, All Rights Reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE. 

		_SAP_HEADER "PIA: Interrupt control test"

		opt		h+o+

		icl		'library.s'

		org		$2000

main:
		ldy		#>testname
		lda		#<testname
		jsr		_testInit
		
		jsr		_screenOff
		jsr		_interruptsOff
		
		;reset port A and port B control
		mva		#$3c pactl
		mva		#$3c pbctl
		
		;clear and disable all POKEY interrupts
		mva		#$00 irqen
		
		;wait for IRQ lines to clear
		pha:pla
		
		;check that interrupts are off
		jsr		checkIRQ
		sta		d0

		;set IRQ bits with all interrupts masked
		lda		#$c0
		sta		pactl
		sta		pbctl
		jsr		checkIRQ
		sta		d1
		
		;check value
		lda		#$ff
		sta		pactl
		sta		pbctl
		lda		pactl
		sta		d2
		lda		pbctl
		sta		d3
				
		;reset PIA
		lda		#$3c
		sta		pactl
		sta		pbctl

		;do asserts
		_ASSERT1	d0, 0, c"Stray IRQ detected with all interrupts disabled."
		_ASSERT1	d1, 0, c"PIA IRQ detected with int bits on and interrupts masked."
		_ASSERT1	d2, $3f, c"Wrote $FF to PACTL, got $%x, expected $3F"
		_ASSERT1	d3, $3f, c"Wrote $FF to PBCTL, got $%x, expected $3F"

		jmp		_testPassed
		
testname:
		dta		c"PIA: Interrupt control test",0

.proc checkIRQ
		mwa		#irqHandler vimirq
		lda		#0
		cli
		:8 nop
		sei
		rts
		
irqHandler:
		pla
		pla
		pla
		lda		#1
		rts
.endp

		run		$2000
		end
